package sample18;

public class Sample05 {
  static class App {
    void print(Object v) {
      //instanceof演算子で確認
      if (v instanceof Integer) {
        // ダウンキャスト
        Integer i = (Integer)v;
        System.out.println("Object -> Integer: " + i);
      } else {
        System.out.println(v.toString());
      }
    }
    // 戻り値型のjava.util.Listへ暗黙の変換
    public java.util.List createList() {
      return new java.util.LinkedList();
    }
    /* このメソッドはコンパイルエラーとなる
    public java.util.LinkedList createLinkedList() {
      java.util.List list = new java.util.LinkedList();
      return list;
    }
    */
  }
  public static void main(String[] args) {
    App app = new App();
    java.util.List list = app.createList();
    list.add(Integer.valueOf(1));
    list.add(Boolean.valueOf(true));
    //明示的なアップキャスト
    list.add((Object)"Hello");
    list.add(app);
    for (Object o: list) {
      app.print(o);
    }
    app = null; // nullは特別
    list = null; // nullは特別
  }
}